--- a/dasdview/dasdview.c
+++ b/dasdview/dasdview.c
@@ -980,298 +1326,538 @@ static void dasdview_print_format1_8_ful
 	       f1->DS1PTRDS.b);
 }
 
-static void dasdview_print_vtoc_f1(dasdview_info_t *info)
+static void dasdview_print_vtoc_f1_raw(format1_label_t *f1)
 {
-	int j;
-
-	printf("--- VTOC format 1 labels ----------------------" \
+	printf("\n--- VTOC format 1 label -----------------------"
 	       "---------------------------------\n");
+	dasdview_print_format1_8_no_head(f1);
+}
 
-	if (info->f1c < 1)
-	{
-	        printf("This VTOC doesn't contain a format 1 label.\n");
-		return;
-	}
+/* Note: A format 8 label uses the same type as format 1 */
+static void dasdview_print_vtoc_f8_raw(format1_label_t *f8)
+{
+	printf("\n--- VTOC format 8 label -----------------------"
+	       "---------------------------------\n");
+	dasdview_print_format1_8_no_head(f8);
+}
 
-	for (j=0; j<info->f1c; j++) {
-		printf("\n--- format 1 DSCB number %d ---\n", j+1);
-		dasdview_print_format1_8_full(&info->f1[j]);
-	}
+static void dasdview_print_extent(extent_t *ext, char *name, int index)
+{
+	printf("%s[%d] : hex %02x%02x%04x%04x%04x%04x\n",
+	       name,
+	       index,
+	       ext->typeind,
+	       ext->seqno,
+	       ext->llimit.cc,
+	       ext->llimit.hh,
+	       ext->ulimit.cc,
+	       ext->ulimit.hh);
+	printf("              typeind    : dec %d, hex %02x\n",
+	       ext->typeind,
+	       ext->typeind);
+	printf("              seqno      : dec %d, hex %02x\n",
+	       ext->seqno, ext->seqno);
+	printf("              llimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       ext->llimit.cc,
+	       ext->llimit.hh,
+	       vtoc_get_cyl_from_cchh(&ext->llimit),
+	       vtoc_get_head_from_cchh(&ext->llimit));
+	printf("              ulimit     : hex %04x%04x "	\
+	       "(cyl %d, trk %d)\n",
+	       ext->ulimit.cc,
+	       ext->ulimit.hh,
+	       vtoc_get_cyl_from_cchh(&ext->ulimit),
+	       vtoc_get_head_from_cchh(&ext->ulimit));
 }
 
-static void dasdview_print_vtoc_f8(dasdview_info_t *info)
+static void dasdview_print_vtoc_f3_raw(format3_label_t *f3)
 {
-	int j;
+	int i;
 
-	printf("--- VTOC format 8 labels ----------------------" \
+	printf("\n--- VTOC format 3 label ----------------------"
 	       "---------------------------------\n");
 
-	if (info->f8c < 1)
-	{
-		printf("This VTOC doesn't contain a format 8 label.\n");
-		return;
-	}
+	printf("DS3KEYID    : ");
+	for (i=0; i<4; i++)
+		printf("%02x", f3->DS3KEYID[i]);
+	printf("\n");
+
+	for (i = 0; i < 4; ++i)
+		dasdview_print_extent(&f3->DS3EXTNT[i], "DS3EXTNT", i);
+
+	printf("DS3FMTID    : dec %d, hex %02x\n",
+	       f3->DS3FMTID, f3->DS3FMTID);
+
+	for (i = 0; i < 9; ++i)
+		dasdview_print_extent(&f3->DS3ADEXT[i], "DS3ADEXT", i);
+
+	printf("DS3PTRDS    : %04x%04x%02x "		\
+	       "(cyl %d, trk %d, blk %d)\n",
+	       f3->DS3PTRDS.cc, f3->DS3PTRDS.hh,
+	       f3->DS3PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&f3->DS3PTRDS),
+	       vtoc_get_head_from_cchhb(&f3->DS3PTRDS),
+	       f3->DS3PTRDS.b);
 
-	for (j=0; j<info->f8c; j++) {
-		printf("\n--- format 8 DSCB number %d ---\n", j+1);
-		dasdview_print_format1_8_full(&info->f8[j]);
-	}
 }
 
-static void
-dasdview_print_vtoc_f4(dasdview_info_t *info)
+static void dasdview_print_vtoc_f4_raw(format4_label_t *f4)
 {
         int i;
 
-	printf("\n--- VTOC format 4 label ----------------------" \
+	printf("\n--- VTOC format 4 label ----------------------"
 	       "---------------------------------\n");
 
-	if (info->f4c < 1)
-	{
-	        printf("This VTOC doesn't contain a format 4 label.\n");
-		return;
-	}
-
 	printf("DS4KEYCD    : ");
-	for (i=0; i<44; i++) printf("%02x", info->f4.DS4KEYCD[i]);
+	for (i=0; i<44; i++) printf("%02x", f4->DS4KEYCD[i]);
 	printf("\nDS4IDFMT    : dec %d, hex %02x\n",
-	       info->f4.DS4IDFMT, info->f4.DS4IDFMT);
+	       f4->DS4IDFMT, f4->DS4IDFMT);
 	printf("DS4HPCHR    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
-	       info->f4.DS4HPCHR.cc, info->f4.DS4HPCHR.hh,
-	       info->f4.DS4HPCHR.b,
-	       vtoc_get_cyl_from_cchhb(&info->f4.DS4HPCHR),
-	       vtoc_get_head_from_cchhb(&info->f4.DS4HPCHR),
-	       info->f4.DS4HPCHR.b);
+	       f4->DS4HPCHR.cc, f4->DS4HPCHR.hh,
+	       f4->DS4HPCHR.b,
+	       vtoc_get_cyl_from_cchhb(&f4->DS4HPCHR),
+	       vtoc_get_head_from_cchhb(&f4->DS4HPCHR),
+	       f4->DS4HPCHR.b);
 	printf("DS4DSREC    : dec %d, hex %04x\n",
-	       info->f4.DS4DSREC, info->f4.DS4DSREC);
+	       f4->DS4DSREC, f4->DS4DSREC);
 	printf("DS4HCCHH    : %04x%04x (cyl %d, trk %d)\n",
-	       info->f4.DS4HCCHH.cc, info->f4.DS4HCCHH.hh,
-	       vtoc_get_cyl_from_cchh(&info->f4.DS4HCCHH),
-	       vtoc_get_head_from_cchh(&info->f4.DS4HCCHH));
+	       f4->DS4HCCHH.cc, f4->DS4HCCHH.hh,
+	       vtoc_get_cyl_from_cchh(&f4->DS4HCCHH),
+	       vtoc_get_head_from_cchh(&f4->DS4HCCHH));
 	printf("DS4NOATK    : dec %d, hex %04x\n",
-	       info->f4.DS4NOATK, info->f4.DS4NOATK);
+	       f4->DS4NOATK, f4->DS4NOATK);
 	printf("DS4VTOCI    : dec %d, hex %02x\n",
-	       info->f4.DS4VTOCI, info->f4.DS4VTOCI);
+	       f4->DS4VTOCI, f4->DS4VTOCI);
 	printf("DS4NOEXT    : dec %d, hex %02x\n",
-	       info->f4.DS4NOEXT, info->f4.DS4NOEXT);
+	       f4->DS4NOEXT, f4->DS4NOEXT);
 	printf("DS4SMSFG    : dec %d, hex %02x\n",
-	       info->f4.DS4SMSFG, info->f4.DS4SMSFG);
+	       f4->DS4SMSFG, f4->DS4SMSFG);
 	printf("DS4DEVAC    : dec %d, hex %02x\n",
-	       info->f4.DS4DEVAC, info->f4.DS4DEVAC);
+	       f4->DS4DEVAC, f4->DS4DEVAC);
 	printf("DS4DSCYL    : dec %d, hex %04x\n",
-	       info->f4.DS4DEVCT.DS4DSCYL, info->f4.DS4DEVCT.DS4DSCYL);
+	       f4->DS4DEVCT.DS4DSCYL, f4->DS4DEVCT.DS4DSCYL);
 	printf("DS4DSTRK    : dec %d, hex %04x\n",
-	       info->f4.DS4DEVCT.DS4DSTRK, info->f4.DS4DEVCT.DS4DSTRK);
+	       f4->DS4DEVCT.DS4DSTRK, f4->DS4DEVCT.DS4DSTRK);
 	printf("DS4DEVTK    : dec %d, hex %04x\n",
-	       info->f4.DS4DEVCT.DS4DEVTK, info->f4.DS4DEVCT.DS4DEVTK);
+	       f4->DS4DEVCT.DS4DEVTK, f4->DS4DEVCT.DS4DEVTK);
 	printf("DS4DEVI     : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVI, info->f4.DS4DEVCT.DS4DEVI);
+	       f4->DS4DEVCT.DS4DEVI, f4->DS4DEVCT.DS4DEVI);
 	printf("DS4DEVL     : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVL, info->f4.DS4DEVCT.DS4DEVL);
+	       f4->DS4DEVCT.DS4DEVL, f4->DS4DEVCT.DS4DEVL);
 	printf("DS4DEVK     : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVK, info->f4.DS4DEVCT.DS4DEVK);
+	       f4->DS4DEVCT.DS4DEVK, f4->DS4DEVCT.DS4DEVK);
 	printf("DS4DEVFG    : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVFG, info->f4.DS4DEVCT.DS4DEVFG);
+	       f4->DS4DEVCT.DS4DEVFG, f4->DS4DEVCT.DS4DEVFG);
 	printf("DS4DEVTL    : dec %d, hex %04x\n",
-	       info->f4.DS4DEVCT.DS4DEVTL, info->f4.DS4DEVCT.DS4DEVTL);
+	       f4->DS4DEVCT.DS4DEVTL, f4->DS4DEVCT.DS4DEVTL);
 	printf("DS4DEVDT    : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVDT, info->f4.DS4DEVCT.DS4DEVDT);
+	       f4->DS4DEVCT.DS4DEVDT, f4->DS4DEVCT.DS4DEVDT);
 	printf("DS4DEVDB    : dec %d, hex %02x\n",
-	       info->f4.DS4DEVCT.DS4DEVDB, info->f4.DS4DEVCT.DS4DEVDB);
+	       f4->DS4DEVCT.DS4DEVDB, f4->DS4DEVCT.DS4DEVDB);
 	printf("DS4AMTIM    : hex ");
-	for (i=0; i<8; i++) printf("%02x", info->f4.DS4AMTIM[i]);
+	for (i=0; i<8; i++) printf("%02x", f4->DS4AMTIM[i]);
 	printf("\nDS4AMCAT    : hex ");
-	for (i=0; i<3; i++) printf("%02x", info->f4.DS4AMCAT[i]);
+	for (i=0; i<3; i++) printf("%02x", f4->DS4AMCAT[i]);
 	printf("\nDS4R2TIM    : hex ");
-	for (i=0; i<8; i++) printf("%02x", info->f4.DS4R2TIM[i]);
+	for (i=0; i<8; i++) printf("%02x", f4->DS4R2TIM[i]);
 	printf("\nres1        : hex ");
-	for (i=0; i<5; i++) printf("%02x", info->f4.res1[i]);
+	for (i=0; i<5; i++) printf("%02x", f4->res1[i]);
 	printf("\nDS4F6PTR    : hex ");
-	for (i=0; i<5; i++) printf("%02x", info->f4.DS4F6PTR[i]);
+	for (i=0; i<5; i++) printf("%02x", f4->DS4F6PTR[i]);
 	printf("\nDS4VTOCE    : hex %02x%02x%04x%04x%04x%04x\n",
-	       info->f4.DS4VTOCE.typeind, info->f4.DS4VTOCE.seqno,
-	       info->f4.DS4VTOCE.llimit.cc, info->f4.DS4VTOCE.llimit.hh,
-	       info->f4.DS4VTOCE.ulimit.cc, info->f4.DS4VTOCE.ulimit.hh);
+	       f4->DS4VTOCE.typeind, f4->DS4VTOCE.seqno,
+	       f4->DS4VTOCE.llimit.cc, f4->DS4VTOCE.llimit.hh,
+	       f4->DS4VTOCE.ulimit.cc, f4->DS4VTOCE.ulimit.hh);
 	printf("              typeind    : dec %d, hex %02x\n",
-	       info->f4.DS4VTOCE.typeind, info->f4.DS4VTOCE.typeind);
+	       f4->DS4VTOCE.typeind, f4->DS4VTOCE.typeind);
 	printf("              seqno      : dec %d, hex %02x\n",
-	       info->f4.DS4VTOCE.seqno, info->f4.DS4VTOCE.seqno);
+	       f4->DS4VTOCE.seqno, f4->DS4VTOCE.seqno);
 	printf("              llimit     : hex %04x%04x (cyl %d, trk %d)\n",
-	       info->f4.DS4VTOCE.llimit.cc, info->f4.DS4VTOCE.llimit.hh,
-	       vtoc_get_cyl_from_cchh(&info->f4.DS4VTOCE.llimit),
-	       vtoc_get_head_from_cchh(&info->f4.DS4VTOCE.llimit));
+	       f4->DS4VTOCE.llimit.cc, f4->DS4VTOCE.llimit.hh,
+	       vtoc_get_cyl_from_cchh(&f4->DS4VTOCE.llimit),
+	       vtoc_get_head_from_cchh(&f4->DS4VTOCE.llimit));
 	printf("              ulimit     : hex %04x%04x (cyl %d, trk %d)\n",
-	       info->f4.DS4VTOCE.ulimit.cc, info->f4.DS4VTOCE.ulimit.hh,
-	       vtoc_get_cyl_from_cchh(&info->f4.DS4VTOCE.ulimit),
-	       vtoc_get_head_from_cchh(&info->f4.DS4VTOCE.ulimit));
+	       f4->DS4VTOCE.ulimit.cc, f4->DS4VTOCE.ulimit.hh,
+	       vtoc_get_cyl_from_cchh(&f4->DS4VTOCE.ulimit),
+	       vtoc_get_head_from_cchh(&f4->DS4VTOCE.ulimit));
 	printf("res2        : hex ");
-	for (i=0; i<10; i++) printf("%02x", info->f4.res2[i]);
+	for (i=0; i<10; i++) printf("%02x", f4->res2[i]);
 	printf("\nDS4EFLVL    : dec %d, hex %02x\n",
-	       info->f4.DS4EFLVL, info->f4.DS4EFLVL);
+	       f4->DS4EFLVL, f4->DS4EFLVL);
 	printf("DS4EFPTR    : hex %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
-	       info->f4.DS4EFPTR.cc, info->f4.DS4EFPTR.hh,
-	       info->f4.DS4EFPTR.b,
-	       vtoc_get_cyl_from_cchhb(&info->f4.DS4EFPTR),
-	       vtoc_get_head_from_cchhb(&info->f4.DS4EFPTR),
-	       info->f4.DS4EFPTR.b);
-	printf("res3        : hex %02x\n", info->f4.res3);
+	       f4->DS4EFPTR.cc, f4->DS4EFPTR.hh,
+	       f4->DS4EFPTR.b,
+	       vtoc_get_cyl_from_cchhb(&f4->DS4EFPTR),
+	       vtoc_get_head_from_cchhb(&f4->DS4EFPTR),
+	       f4->DS4EFPTR.b);
+	printf("res3        : hex %02x\n", f4->res3);
 	printf("DS4DCYL     : dec %d, hex %08x\n",
-	       info->f4.DS4DCYL, info->f4.DS4DCYL);
+	       f4->DS4DCYL, f4->DS4DCYL);
 	printf("res4        : hex ");
-	for (i=0; i<2; i++) printf("%02x", info->f4.res4[i]);
+	for (i=0; i<2; i++) printf("%02x", f4->res4[i]);
 	printf("\nDS4DEVF2    : dec %d, hex %02x\n",
-	       info->f4.DS4DEVF2, info->f4.DS4DEVF2);
-	printf("res5        : hex %02x\n", info->f4.res5);
+	       f4->DS4DEVF2, f4->DS4DEVF2);
+	printf("res5        : hex %02x\n", f4->res5);
 }
 
-static void
-dasdview_print_vtoc_f5(dasdview_info_t *info)
+static void dasdview_print_vtoc_f5_raw(format5_label_t *f5)
 {
         int i;
 
 	printf("\n--- VTOC format 5 label ----------------------" \
 	       "---------------------------------\n");
 
-	if (info->f5c < 1)
-	{
-	        printf("This VTOC doesn't contain a format 5 label.\n");
-		return;
-	}
-
 	printf("key identifier\n        DS5KEYID    : ");
-	for (i=0; i<4; i++) printf("%02x", info->f5.DS5KEYID[i]);
+	for (i=0; i<4; i++) printf("%02x", f5->DS5KEYID[i]);
 	printf("\nfirst extent description\n");
 	printf("        DS5AVEXT    : %04x%04x%02x " \
 	       "(start trk: %d, length: %d cyl, %d trk)\n",
-	       info->f5.DS5AVEXT.t,  info->f5.DS5AVEXT.fc,
-	       info->f5.DS5AVEXT.ft, info->f5.DS5AVEXT.t,
-	       info->f5.DS5AVEXT.fc, info->f5.DS5AVEXT.ft);
+	       f5->DS5AVEXT.t,  f5->DS5AVEXT.fc,
+	       f5->DS5AVEXT.ft, f5->DS5AVEXT.t,
+	       f5->DS5AVEXT.fc, f5->DS5AVEXT.ft);
 	printf("next 7 extent descriptions\n");
 	for (i=0; i<7; i++)
         {
 	        printf("        DS5EXTAV[%d] : %04x%04x%02x " \
 		       "(start trk: %d, length: %d cyl, %d trk)\n", i+2,
-		       info->f5.DS5EXTAV[i].t,  info->f5.DS5EXTAV[i].fc,
-		       info->f5.DS5EXTAV[i].ft, info->f5.DS5EXTAV[i].t,
-		       info->f5.DS5EXTAV[i].fc, info->f5.DS5EXTAV[i].ft);
+		       f5->DS5EXTAV[i].t,  f5->DS5EXTAV[i].fc,
+		       f5->DS5EXTAV[i].ft, f5->DS5EXTAV[i].t,
+		       f5->DS5EXTAV[i].fc, f5->DS5EXTAV[i].ft);
 	}
 	printf("format identifier\n" \
 	       "        DS5FMTID    : dec %d, hex %02x\n",
-	       info->f5.DS5FMTID, info->f5.DS5FMTID);
+	       f5->DS5FMTID, f5->DS5FMTID);
 	printf("next 18 extent descriptions\n");
 	for (i=0; i<18; i++)
         {
 	        printf("        DS5MAVET[%d] : %04x%04x%02x " \
 		       "(start trk: %d, length: %d cyl, %d trk)\n", i+9,
-		       info->f5.DS5MAVET[i].t,  info->f5.DS5MAVET[i].fc,
-		       info->f5.DS5MAVET[i].ft, info->f5.DS5MAVET[i].t,
-		       info->f5.DS5MAVET[i].fc, info->f5.DS5MAVET[i].ft);
+		       f5->DS5MAVET[i].t,  f5->DS5MAVET[i].fc,
+		       f5->DS5MAVET[i].ft, f5->DS5MAVET[i].t,
+		       f5->DS5MAVET[i].fc, f5->DS5MAVET[i].ft);
 	}
 	printf("pointer to next format 5 label\n" \
 	       "        DS5PTRDS    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
-	       info->f5.DS5PTRDS.cc, info->f5.DS5PTRDS.hh,
-	       info->f5.DS5PTRDS.b,
-	       vtoc_get_cyl_from_cchhb(&info->f5.DS5PTRDS),
-	       vtoc_get_head_from_cchhb(&info->f5.DS5PTRDS),
-	       info->f5.DS5PTRDS.b);
+	       f5->DS5PTRDS.cc, f5->DS5PTRDS.hh,
+	       f5->DS5PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&f5->DS5PTRDS),
+	       vtoc_get_head_from_cchhb(&f5->DS5PTRDS),
+	       f5->DS5PTRDS.b);
 }
 
-static void
-dasdview_print_vtoc_f7(dasdview_info_t *info)
+static void dasdview_print_vtoc_f7_raw(format7_label_t *f7)
 {
         int i;
 
 	printf("\n--- VTOC format 7 label ----------------------" \
 	       "---------------------------------\n");
 
-	if (info->f7c < 1)
-	{
-	        printf("This VTOC doesn't contain a format 7 label.\n");
-		return;
-	}
-
 	printf("key identifier\n        DS7KEYID    : ");
-	for (i=0; i<4; i++) printf("%02x", info->f7.DS7KEYID[i]);
+	for (i=0; i<4; i++) printf("%02x", f7->DS7KEYID[i]);
 	printf("\nfirst 5 extent descriptions\n");
 	for (i=0; i<5; i++)
 	{
 	        printf("        DS7EXTNT[%d] : %08x %08x " \
 		       "(start trk %d, end trk %d)\n", i+1,
-		       info->f7.DS7EXTNT[i].a, info->f7.DS7EXTNT[i].b,
-		       info->f7.DS7EXTNT[i].a, info->f7.DS7EXTNT[i].b);
+		       f7->DS7EXTNT[i].a, f7->DS7EXTNT[i].b,
+		       f7->DS7EXTNT[i].a, f7->DS7EXTNT[i].b);
 	}
 	printf("format identifier\n" \
 	       "        DS7FMTID    : dec %d, hex %02x\n",
-	       info->f7.DS7FMTID, info->f7.DS7FMTID);
+	       f7->DS7FMTID, f7->DS7FMTID);
 	printf("next 11 extent descriptions\n");
 	for (i=0; i<11; i++)
 	{
 	        printf("        DS7ADEXT[%d] : %08x %08x " \
 		       "(start trk %d, end trk %d)\n", i+6,
-		       info->f7.DS7ADEXT[i].a, info->f7.DS7ADEXT[i].b,
-		       info->f7.DS7ADEXT[i].a, info->f7.DS7ADEXT[i].b);
+		       f7->DS7ADEXT[i].a, f7->DS7ADEXT[i].b,
+		       f7->DS7ADEXT[i].a, f7->DS7ADEXT[i].b);
 	}
 	printf("reserved field\n        res1        : ");
-	for (i=0; i<2; i++) printf("%02x", info->f7.res1[i]);
+	for (i=0; i<2; i++) printf("%02x", f7->res1[i]);
 	printf("\npointer to next format 7 label\n" \
 	       "        DS7PTRDS    : %04x%04x%02x " \
 	       "(cyl %d, trk %d, blk %d)\n",
-	       info->f7.DS7PTRDS.cc, info->f7.DS7PTRDS.hh,
-	       info->f7.DS7PTRDS.b,
-	       vtoc_get_cyl_from_cchhb(&info->f7.DS7PTRDS),
-	       vtoc_get_head_from_cchhb(&info->f7.DS7PTRDS),
-	       info->f7.DS7PTRDS.b);
+	       f7->DS7PTRDS.cc, f7->DS7PTRDS.hh,
+	       f7->DS7PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&f7->DS7PTRDS),
+	       vtoc_get_head_from_cchhb(&f7->DS7PTRDS),
+	       f7->DS7PTRDS.b);
 }
 
-static void
-dasdview_print_vtoc_f9(dasdview_info_t *info)
+static void dasdview_print_vtoc_f9_nohead(format9_label_t *f9)
 {
 	unsigned int i;
-	int j;
 
+	printf("DS9KEYID    : dec %d, hex %02x\n",
+	       f9->DS9KEYID, f9->DS9KEYID);
+	printf("DS9SUBTY    : dec %d, hex %02x\n",
+	       f9->DS9SUBTY, f9->DS9SUBTY);
+	printf("DS9NUMF9    : dec %d, hex %02x\n",
+	       f9->DS9NUMF9, f9->DS9NUMF9);
+
+	printf("res1        : hex ");
+	for (i=0; i < sizeof(f9->res1); i++) {
+		if ((i > 0) && (i % 16 == 0))
+			printf("\n                  ");
+		printf("%02x", f9->res1[i]);
+		if ((i+9) % 16 == 0)
+			printf(" ");
+	}
+	printf("\n");
+
+	printf("DS9FMTID    : dec %d, hex %02x\n",
+	       f9->DS9FMTID, f9->DS9FMTID);
+
+	printf("res2        : hex ");
+	for (i=0; i < sizeof(f9->res2); i++) {
+		if ((i > 0) && (i % 16 == 0))
+			printf("\n                  ");
+		printf("%02x", f9->res2[i]);
+		if ((i+9) % 16 == 0)
+			printf(" ");
+	}
+	printf("\n");
+	printf("pointer to next format 9 label\n"
+	       "        DS9PTRDS    : %04x%04x%02x "
+	       "(cyl %d, trk %d, blk %d)\n",
+	       f9->DS9PTRDS.cc, f9->DS9PTRDS.hh,
+	       f9->DS9PTRDS.b,
+	       vtoc_get_cyl_from_cchhb(&f9->DS9PTRDS),
+	       vtoc_get_head_from_cchhb(&f9->DS9PTRDS),
+	       f9->DS9PTRDS.b);
+}
+
+static void dasdview_print_vtoc_f9_raw(format9_label_t *f9)
+{
 	printf("\n--- VTOC format 9 label ----------------------" \
 	       "---------------------------------\n");
+	dasdview_print_vtoc_f9_nohead(f9);
+}
+
+static void dasdview_print_vtoc_dscb(dasdview_info_t *info, void *dscb)
+{
+	format1_label_t *tmp = dscb;
+
+	switch (tmp->DS1FMTID) {
+        case 0x00:
+		break;
+        case 0xf1:
+		if (info->vtoc_f1 || info->vtoc_all)
+			dasdview_print_vtoc_f1_raw(dscb);
+		break;
+        case 0xf3:
+		if (info->vtoc_f3 || info->vtoc_all)
+			dasdview_print_vtoc_f3_raw(dscb);
+		break;
+        case 0xf4:
+		if (info->vtoc_f4 || info->vtoc_all)
+			dasdview_print_vtoc_f4_raw(dscb);
+		break;
+        case 0xf5:
+		if (info->vtoc_f5 || info->vtoc_all)
+			dasdview_print_vtoc_f5_raw(dscb);
+		break;
+        case 0xf7:
+		if (info->vtoc_f7 || info->vtoc_all)
+			dasdview_print_vtoc_f7_raw(dscb);
+		break;
+        case 0xf8:
+		if (info->vtoc_f8 || info->vtoc_all)
+			dasdview_print_vtoc_f8_raw(dscb);
+		break;
+        case 0xf9:
+		if (info->vtoc_f9 || info->vtoc_all)
+			dasdview_print_vtoc_f9_raw(dscb);
+		break;
+        default:
+		printf("unrecognized DSCB of type: %x \n\n", tmp->DS1FMTID);
+                break;
+        }
+}
+
+static void dasdview_print_vtoc_f1(dasdview_info_t *info)
+{
+	int j;
+
+	printf("--- VTOC format 1 labels ----------------------"
+	       "---------------------------------\n");
+
+	if (info->f1c < 1)
+	{
+	        printf("This VTOC doesn't contain a format 1 label.\n");
+		return;
+	}
+
+	for (j=0; j<info->f1c; j++) {
+		printf("\n--- format 1 DSCB number %d ---\n", j+1);
+		dasdview_print_format1_8_no_head(&info->f1[j]);
+	}
+}
+
+static void dasdview_print_vtoc_f8(dasdview_info_t *info)
+{
+	int j;
+
+	printf("--- VTOC format 8 labels ----------------------"
+	       "---------------------------------\n");
+
+	if (info->f8c < 1)
+	{
+		printf("This VTOC doesn't contain a format 8 label.\n");
+		return;
+	}
+
+	for (j=0; j<info->f8c; j++) {
+		printf("\n--- format 8 DSCB number %d ---\n", j+1);
+		dasdview_print_format1_8_no_head(&info->f8[j]);
+	}
+}
+
+static void dasdview_print_vtoc_f4(dasdview_info_t *info)
+{
+	if (info->f4c < 1) {
+		printf("\n--- VTOC format 4 label ----------------------" \
+		       "---------------------------------\n");
+	        printf("This VTOC doesn't contain a format 4 label.\n");
+		return;
+	}
+	dasdview_print_vtoc_f4_raw(&info->f4);
+}
+
+static void dasdview_print_vtoc_f5(dasdview_info_t *info)
+{
+	if (info->f5c < 1)
+	{
+		printf("\n--- VTOC format 5 label ----------------------" \
+		       "---------------------------------\n");
+	        printf("This VTOC doesn't contain a format 5 label.\n");
+		return;
+	}
+	dasdview_print_vtoc_f5_raw(&info->f5);
+}
 
+static void dasdview_print_vtoc_f7(dasdview_info_t *info)
+{
+	if (info->f7c < 1)
+	{
+		printf("\n--- VTOC format 7 label ----------------------"
+		       "---------------------------------\n");
+	        printf("This VTOC doesn't contain a format 7 label.\n");
+		return;
+	}
+	dasdview_print_vtoc_f7_raw(&info->f7);
+}
+
+static void dasdview_print_vtoc_f9(dasdview_info_t *info)
+{
+	int j;
+
+	printf("\n--- VTOC format 9 label ----------------------"
+	       "---------------------------------\n");
 	if (info->f9c < 1) {
 	        printf("This VTOC doesn't contain a format 9 label.\n");
 		return;
 	}
-
-	for (j=0; j<info->f9c; j++) {
+	for (j = 0; j < info->f9c; j++) {
 		printf("\n--- format 9 DSCB number %d ---\n", j+1);
-		printf("DS9KEYID    : dec %d, hex %02x\n",
-		       info->f9[j].DS9KEYID, info->f9[j].DS9KEYID);
-		printf("DS9SUBTY    : dec %d, hex %02x\n",
-		       info->f9[j].DS9SUBTY, info->f9[j].DS9SUBTY);
-		printf("DS9NUMF9    : dec %d, hex %02x\n",
-		       info->f9[j].DS9NUMF9, info->f9[j].DS9NUMF9);
-
-		printf("res1        : hex ");
-		for (i=0; i < sizeof(info->f9[j].res1); i++) {
-			if ((i > 0) && (i % 16 == 0))
-				printf("\n                  ");
-			printf("%02x", info->f9[j].res1[i]);
-			if ((i+9) % 16 == 0)
-				printf(" ");
-		}
-		printf("\n");
+		dasdview_print_vtoc_f9_nohead(&info->f9[j]);
+	}
+}
 
-		printf("DS9FMTID    : dec %d, hex %02x\n",
-		       info->f9[j].DS9FMTID, info->f9[j].DS9FMTID);
+static void dasdview_print_vtoc_f3(dasdview_info_t *info)
+{
+	/* dasdfmt formatted DASD devices have no format3 labels, but since the
+	 *  option exists for raw DASDs, we need to have some sensible message
+	 */
+	printf("\n--- VTOC format 3 label ----------------------"	\
+	       "---------------------------------\n");
+	printf("This VTOC doesn't contain a format 3 label.\n");
+	return;
+}
 
-		printf("res2        : hex ");
-		for (i=0; i < sizeof(info->f9[j].res2); i++) {
-			if ((i > 0) && (i % 16 == 0))
-				printf("\n                  ");
-			printf("%02x", info->f9[j].res2[i]);
-			if ((i+9) % 16 == 0)
-				printf(" ");
-		}
-		printf("\n");
+static void dasdview_print_vtoc_standard(dasdview_info_t *info)
+{
+	dasdview_read_vtoc(info);
+
+	if (info->vtoc_info || info->vtoc_all)
+		dasdview_print_vtoc_info(info);
+
+	if (info->vtoc_f4 || info->vtoc_all)
+	        dasdview_print_vtoc_f4(info);
+
+	if (info->vtoc_f5 || info->vtoc_all)
+	        dasdview_print_vtoc_f5(info);
+
+	if (info->vtoc_f7 || info->vtoc_all)
+	        dasdview_print_vtoc_f7(info);
+
+	if (info->vtoc_f1 || info->vtoc_all)
+	        dasdview_print_vtoc_f1(info);
+
+	if (info->vtoc_f8 || info->vtoc_all)
+		dasdview_print_vtoc_f8(info);
+
+	if (info->vtoc_f9 || info->vtoc_all)
+		dasdview_print_vtoc_f9(info);
+
+	if (info->vtoc_f3 || info->vtoc_all)
+	        dasdview_print_vtoc_f3(info);
+}
+
+/* a simple routine to print all records in the vtoc */
+static void dasdview_print_vtoc_raw(dasdview_info_t *info)
+{
+	struct dscbiterator *it;
+	struct dscb *record;
+	int rc;
+
+	rc = lzds_dasd_read_vlabel(info->dasd);
+	if (rc) {
+		zt_error_print("error when reading label from device:"
+			       " rc=%d\n", rc);
+		exit(-1);
+	}
+	rc = lzds_dasd_read_rawvtoc(info->dasd);
+	if (rc == EINVAL) {
+		zt_error_print("dasdview: Cannot read VTOC because disk does"
+			       " not contain valid VOL1 label.\n",
+			       info->device);
+		exit(-1);
+	} else if (rc) {
+		zt_error_print("error when reading vtoc from device:"
+			       " rc=%d\n", rc);
+		exit(-1);
 	}
+	rc = lzds_dasd_get_rawvtoc(info->dasd, &info->rawvtoc);
+	if (rc || !info->rawvtoc) {
+		zt_error_print("dasdview: libvtoc could not read vtoc\n");
+		exit(-1);
+	}
+
+	if (info->vtoc_info || info->vtoc_all)
+		dasdview_print_vtoc_info_raw(info);
+
+	rc = lzds_raw_vtoc_alloc_dscbiterator(info->rawvtoc, &it);
+	if (rc) {
+		zt_error_print("dasdview: could not allocate DSCB iterator\n");
+		exit(-1);
+	}
+	while (!lzds_dscbiterator_get_next_dscb(it, &record))
+		dasdview_print_vtoc_dscb(info, record);
+	lzds_dscbiterator_free(it);
+}
+
+static void dasdview_print_vtoc(dasdview_info_t *info)
+{
+	if (info->raw_track_access)
+		dasdview_print_vtoc_raw(info);
+	else
+		dasdview_print_vtoc_standard(info);
 }
 
 static int
@@ -1333,8 +1919,7 @@ dasdview_print_format2(unsigned int size
 	return 0;
 }
 
-static int
-dasdview_view(dasdview_info_t *info)
+static void dasdview_view_standard(dasdview_info_t *info)
 {
 	unsigned char  dumpstr[DUMP_STRING_SIZE];
 	unsigned long long i=0, j=0, k=0, count=0;
@@ -1478,7 +2063,209 @@ dasdview_view(dasdview_info_t *info)
 		       "------+----------+----------+\n\n");
 	}
 
-	return 0;
+}
+
+static void dasdview_print_format_raw(unsigned int size, char *dumpstr)
+{
+	unsigned int i;
+	char asc[17], ebc[17];
+	unsigned int residual, count;
+	char *data;
+
+	data = dumpstr;
+	residual = size;
+	while (residual) {
+		/* we handle at most 16 bytes per line */
+		count = min(residual, 16);
+		bzero(asc, 17);
+		bzero(ebc, 17);
+		printf("|");
+		memcpy(asc, data, count);
+		memcpy(ebc, data, count);
+
+		for (i = 0; i < 16; ++i) {
+			if ((i % 4) == 0)
+				printf(" ");
+			if ((i % 8) == 0)
+				printf(" ");
+			if (i < count)
+				printf("%02X", data[i]);
+			else
+				printf("  ");
+		}
+		vtoc_ebcdic_dec(asc, asc, count);
+		dot(asc);
+		dot(ebc);
+		printf("  | %16.16s | %16.16s |\n", asc, ebc);
+		data += count;
+		residual -= count;
+	}
+}
+
+/* gets the pointer to an eckd record structure in memory and
+ * prints a hex/ascii/ebcdic dump for it
+ */
+static void dasdview_print_raw_record(char *rec)
+{
+
+	struct eckd_count *ecount;
+	unsigned int cyl, head;
+
+	ecount = (struct eckd_count *)rec;
+	/* Note: the first 5 bytes of the count area are the
+	 * record ID and by convention these bytes are interpreted
+	 * as CCHHR (or ccccCCChR for large volumes)
+	 */
+	cyl = vtoc_get_cyl_from_cchhb(&ecount->recid);
+	head = vtoc_get_head_from_cchhb(&ecount->recid);
+	printf("+-----------------------------------------"
+	       "-------------------------------------+\n");
+	printf("| count area:                                    "
+	       "                              |\n");
+	printf("|          hex: %016llX                          "
+	       "                     |\n",
+	       *((unsigned long long *)ecount));
+	printf("|     cylinder:        %9d                 "
+	       "                              |\n", cyl);
+	printf("|         head:        %9d                 "
+	       "                              |\n", head);
+	printf("|       record:        %9d                 "
+	       "                              |\n", ecount->recid.b);
+	printf("|   key length:        %9d                 "
+	       "                              |\n", ecount->kl);
+	printf("|  data length:        %9d                 "
+	       "                              |\n", ecount->dl);
+	printf("+-----------------------------------------"
+	       "-------------------------------------+\n");
+	printf("| key area:                               "
+	       "                                     |\n");
+	printf("| HEXADECIMAL                            |"
+	       " EBCDIC           | ASCII            |\n");
+	printf("|  01....04 05....08  09....12 13....16  |"
+	       " 1.............16 | 1.............16 |\n");
+	printf("+----------------------------------------+"
+	       "------------------+------------------+\n");
+	dasdview_print_format_raw(ecount->kl, rec + sizeof(*ecount));
+	printf("+----------------------------------------+"
+	       "------------------+------------------+\n");
+	printf("| data area:                              "
+	       "                                     |\n");
+	printf("| HEXADECIMAL                            |"
+	       " EBCDIC           | ASCII            |\n");
+	printf("|  01....04 05....08  09....12 13....16  |"
+	       " 1.............16 | 1.............16 |\n");
+	printf("+----------------------------------------+"
+	       "------------------+------------------+\n");
+	dasdview_print_format_raw(ecount->dl,
+				  rec + sizeof(*ecount) + ecount->kl);
+	printf("+----------------------------------------+"
+	       "------------------+------------------+\n");
+}
+
+static void dasdview_print_raw_track(char *trackdata,
+				     unsigned int cyl,
+				     unsigned int head)
+{
+	struct eckd_count *ecount;
+	char *data;
+	u_int32_t record;
+
+	record = 0;
+	data = trackdata;
+
+	do {
+		printf("cylinder %u, head %u, record %u\n",
+		       cyl, head, record);
+		dasdview_print_raw_record(data);
+		printf("\n");
+
+		ecount = (struct eckd_count *)data;
+		data += sizeof(*ecount) + ecount->kl + ecount->dl;
+		++record;
+
+		if ((*(unsigned long long *)data) == ENDTOKEN) {
+			break;
+		}
+		if ((unsigned long)data >=
+		    (unsigned long)trackdata + RAWTRACKSIZE) {
+			break;
+		}
+	} while (1);
+}
+
+static void dasdview_view_raw(dasdview_info_t *info)
+{
+	u_int64_t residual, trckstart, trckend, track, trckbuffsize;
+	u_int64_t tracks_to_read, trckcount, i;
+	char *trackdata;
+	char *data;
+	int rc;
+	struct dasdhandle *dasdh;
+
+	trckstart = info->begin / RAWTRACKSIZE;
+	tracks_to_read = info->size / RAWTRACKSIZE;
+
+	/* TODO: how large should we make our buffer?
+	 * The DASD device driver cannot read more than 16 tracks at once
+	 * but we can read a larger blob and the block layer will split up
+	 * the requests for us.
+	 */
+	trckbuffsize = min(tracks_to_read, 16);
+	/* track data must be page aligned for O_DIRECT */
+	trackdata = memalign(4096, trckbuffsize * RAWTRACKSIZE);
+	if (!trackdata) {
+		zt_error_print("failed to allocate memory\n");
+		exit(-1);
+	}
+	rc = lzds_dasd_alloc_dasdhandle(info->dasd, &dasdh);
+	if (rc) {
+		zt_error_print("failed to allocate memory\n");
+		exit(-1);
+	}
+	rc = lzds_dasdhandle_open(dasdh);
+	if (rc) {
+		lzds_dasdhandle_free(dasdh);
+		zt_error_print("failed to open device\n");
+		exit(-1);
+	}
+	/* residual is the number of tracks we still have to read */
+	residual = tracks_to_read;
+	track = trckstart;
+	while (residual) {
+		trckcount = min(trckbuffsize, residual);
+		trckend = track + trckcount - 1;
+		rc = lzds_dasdhandle_read_tracks_to_buffer(dasdh, track,
+							   trckend, trackdata);
+		if (rc) {
+			perror("Error on read");
+			exit(-1);
+		}
+		data = trackdata;
+		for (i = 0; i < trckcount; ++i) {
+			dasdview_print_raw_track(data, track / info->geo.heads,
+						track % info->geo.heads);
+			data += RAWTRACKSIZE;
+			++track;
+		}
+		residual -= trckcount;
+	}
+
+	free(trackdata);
+
+	rc = lzds_dasdhandle_close(dasdh);
+	lzds_dasdhandle_free(dasdh);
+	if (rc < 0) {
+		perror("Error on closing file");
+		exit(-1);
+	}
+}
+
+static void dasdview_view(dasdview_info_t *info)
+{
+	if (info->raw_track_access)
+		dasdview_view_raw(info);
+	else
+		dasdview_view_standard(info);
 }
 
 static void
@@ -1502,6 +2289,7 @@ int main(int argc, char * argv[]) {
 	char *begin_param_str = NULL;
 	char *size_param_str  = NULL;
 	char *endptr          = NULL;
+	int rc;
 
 	bzero (&info, sizeof(info));
 	while (1)
